"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactSyntaxHighlighter = require("react-syntax-highlighter");

var _supportedLanguages = require("../supportedLanguages");

var _themeBuilder = require("../themes/themeBuilder");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var Code = /*#__PURE__*/function (_PureComponent) {
  (0, _inherits2.default)(Code, _PureComponent);

  var _super = _createSuper(Code);

  function Code() {
    (0, _classCallCheck2.default)(this, Code);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(Code, [{
    key: "render",
    value: function render() {
      var _applyTheme = (0, _themeBuilder.applyTheme)(this.props.theme),
          inlineCodeStyle = _applyTheme.inlineCodeStyle;

      var language = (0, _supportedLanguages.normalizeLanguage)(this.props.language);
      var props = {
        language: language,
        PreTag: this.props.preTag,
        style: this.props.codeStyle || inlineCodeStyle,
        codeTagProps: this.props.codeTagProps
      };
      return /*#__PURE__*/_react.default.createElement(_reactSyntaxHighlighter.PrismAsyncLight, (0, _extends2.default)({
        "data-code-lang": this.props.language,
        "data-testid": this.props.testId
      }, props), this.props.text);
    }
  }]);
  return Code;
}(_react.PureComponent);

exports.default = Code;
(0, _defineProperty2.default)(Code, "defaultProps", {
  theme: {},
  codeTagProps: {},
  preTag: 'span'
});